exports = class AlexaPlusUnity {
    constructor(iotEndpoint, iotThingName, AWS, iotRegion = "us-east-1") {
        this.AWS = AWS;
        //Environment Configuration
        var config = {};

        config.IOT_BROKER_ENDPOINT      = iotEndpoint.toLowerCase();

        config.IOT_BROKER_REGION        = iotRegion;

        config.IOT_THING_NAME           = iotThingName;

        this.AWS.config.region = config.IOT_BROKER_REGION;

        //Initializing client for IoT

        this.iotData = new this.AWS.IotData({endpoint: config.IOT_BROKER_ENDPOINT});
    };

    sendEvent(payloadObj) {
        return new Promise((resolve, reject) => {
            // var payloadObj = { 
            //     "state": {
            //         "desired": {
            //             "pump":1
            //         }
            //     }
            // };

            //Prepare the parameters of the update call
            var paramsUpdate = {
                "thingName" : config.IOT_THING_NAME,
                "payload" : JSON.stringify(payloadObj)
            };

            //Update Device Shadow
            this.iotData.updateThingShadow(paramsUpdate, function(err, data) {
                if (err){
                    reject(err)
                }

                else {
                    resolve(data);
                }
            });
        });
    }
}